<?php

class WECR_Db_Upgrades{

	function __construct(){
		add_action( 'admin_notices', array( $this, 'db_upgrade_check' ) );
	}

	public function db_upgrade_check(){

		$dbv = get_option( 'wecr_db_version' );

		if ( isset( $_GET['wecr_db_upgrade'] ) && $_GET['wecr_db_upgrade'] == true ){

			if ( $dbv < '1.2.1' || $dbv === false ){
				$this->run_upgrade_routine_121();
				delete_option( 'wecr_db_version' );
				add_option( 'wecr_db_version', '1.2.1', '', 'no' );
			} // if 1.2.1
		}

		$dbv = get_option( 'wecr_db_version' );

		if ( $dbv < WECR_DB_VERSION || $dbv === false ){

		?>
				<div id="message" class="error">
					<p>Easy Content Restriction <strong>needs</strong> to upgrade it's data to continue to function. Click <a href="<?php echo admin_url(); ?>?wecr_db_upgrade=true">here</a> to upgrade the database.</p>
				</div>
		<?php
		} // if

	} // db_upgrade_check

	private function run_upgrade_routine_121(){

		$post_args = array(
			'post_type' => 'any',
			'posts_per_page' => -1, // all content
			'meta_query' => array(
				array(
					'meta_key' => '_wecr_easy_restrict_content',
					'compare' => 'EXISTS',
				)
			)
		);

		$upgrade_products = get_posts( $post_args );

		foreach( $upgrade_products as $product ){
			$this->maybe_change_to_array( $product->ID );
		}

	}

	private function maybe_change_to_array( $post_id ){

		$meta_value = get_post_meta( absint( $post_id ), '_wecr_easy_restrict_content', true );

		if ( ! empty( $meta_value ) && ! is_array( $meta_value ) ){
			$meta_value_array = array();
			$meta_value_array[] = $meta_value;
			update_post_meta( absint( $post_id ), '_wecr_easy_restrict_content', $meta_value_array );
		}


	}

} // WECR_Db_Upgrades

$GLOBALS['wecr_db_up'] = new WECR_Db_Upgrades();
